automake-ng
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[Automake-NG] [FYI] [ng] coverage: iteration variable in $(foreach ...)


From: Stefano Lattarini
Subject: [Automake-NG] [FYI] [ng] coverage: iteration variable in $(foreach ...) is temporary
Date: Tue, 24 Jul 2012 15:12:06 +0200

* t/spy-foreach.sh: New test.  Check that, after a "$(foreach x,...)"
loop, the make variable $(x) is:
  - restored to the original variable it had before the 'foreach'
    loop, if it was already set; and
  - is re-unset otherwise.

Signed-off-by: Stefano Lattarini <address@hidden>
---
 t/spy-foreach.sh | 39 +++++++++++++++++++++++++++++++++++++++
 1 file changed, 39 insertions(+)
 create mode 100755 t/spy-foreach.sh

diff --git a/t/spy-foreach.sh b/t/spy-foreach.sh
new file mode 100755
index 0000000..e71bd81
--- /dev/null
+++ b/t/spy-foreach.sh
@@ -0,0 +1,39 @@
+#! /bin/sh
+# Copyright (C) 2012 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Verify that iterating variable used in a $(foreach ...) builtin is
+# only temporary, and restored to its previous variable if it was already
+# set.
+
+am_create_testdir=empty
+. ./defs || exit 1
+
+cat > Makefile <<'END'
+$(foreach x,1 2,$(warning foo-$(x))$(eval y:=$$(x)))
+$(foreach u,oops ko,$(warning bar-$(u))$(eval v=$(u)))
+test:
+       test .'$(x)' = .
+       test .'$(origin x)' = .'undefined'
+       test .'$(y)' = .2
+       test .'$(v)' = .ko
+       test .'$(u)' = .ok
+       test .'$(origin u)' = .'command line'
+END
+
+x= y= u= v=; unset x y u v
+$MAKE test u=ok
+
+:
-- 
1.7.12.rc0




reply via email to

[Prev in Thread] Current Thread [Next in Thread]